#ifdef WIN32
#include <direct.h>
#include <windows.h>
#endif

#include <stdio.h>
#include <stdlib.h>
#include <gl/gl.h>
#include <gl/glu.h>

#include "globals.h"
#include "util.h"
#include "DNA.h"
#include "World.h"

extern Settings settings;
extern FSettings fsettings;

//Globals.

Settings settings;
FSettings fsettings;

//General utility functions.

char* LoadGenes()
{
	FILE* f = fopen( "SceneGenes.txt", "r" );

	if ( !f ) return NULL;

	fseek( f, 0, SEEK_END );
	int size = ftell( f );
	fseek( f, 0, SEEK_SET );

	if ( !size ) return NULL;

	char* dfile = new char[size];
	for ( int a = 0 ; a < size ; a++ ) dfile[a] = fgetc( f );

	fclose( f );

	return dfile;
}

int save()
{
	if ( !settings.save ) return 0;

	FILE* f = fopen( "SceneGenes.tmp", "w" );
	if ( !f ) return 1;
	//world->SaveGenes( f );
	int e = fclose( f );
	if ( e ) return e;

	unlink( "SceneGenes.txt" );

	return rename( "SceneGenes.tmp", "SceneGenes.txt" );
}

float RandFloat()
{ 
	 return rand() / ( 1.0f * RAND_MAX );
}

int RandInt( int foo )
{
	return rand() % ( foo + 1 );
}

void SetColor( Color c )
{
	float alpha = settings.alpha;
	switch ( c )
	{
	case Black:
		glColor4f( 0.0, 0.0, 0.0, alpha );
		break;
	case Blue:
		glColor4f( 0.0, 0.0, 1.0, alpha );
		break;
	case Cyan:
		glColor4f( 0.0, 1.0, 1.0, alpha );
		break;
	case Green:
		glColor4f( 0.0, 1.0, 0.0, alpha );
		break;
	case Grey:
		glColor4f( 0.5, 0.5, 0.5, alpha );
		break;
	case Magenta:
		glColor4f( 1.0, 0.0, 1.0, alpha );
		break;
	case Red:
		glColor4f( 1.0, 0.0, 0.0, alpha );
		break;
	case Yellow:
		glColor4f( 1.0, 1.0, 0.0, alpha );
		break;
	}
}

